# TimeTable Zope product
# Utils
#
# Peter Bengtsson <mail@peterbe.com>
# Start date: 03/10 -01
#

try:
    from DateTime.DateTime import DateTime
except ImportError:
    print "DateTime could not be imported"

import string


def encodeSMSMessage(m):
    """ string replace according to sms-wap.com
    """
    replacers = {'\n':' ','\t':' ',
                 '\n\t':' ','\t\n':' ',
                 '\r':' '}
    for k,v in replacers.items():
        m=m.replace(k,v)
    m=_removeExcessSpaces(m)
    return m

def _removeExcessSpaces(s):
    """
        Make "this is  a abnormal    sentence"
        Into "this is a abnormal sentence"
    """
    s=str(s).strip() # paranoia
    sss = list(s)
    new_s=[]
    last_was_space=0
    for s in sss:
        if s==' ':
            if not last_was_space:
                new_s.append(s)
            last_was_space=1
        else:
            last_was_space=0
            new_s.append(s)


    return string.join(new_s,'')

def decodeSMSMessage(m):
    """ string replace according to sms-wap.com
    """
    return m

def findEventId(self):
    """ return an appropriate id that is not taken """
    ids = self.objectIds('TimeTable Event')
    ids_n = []
    for id in ids:
        try:
            ids_n.append(int(id))
        except:pass
    if len(ids_n) > 0:
        newid = max(ids_n)+1
    else:
        newid = 1
    return string.zfill(newid,2)

def filterDuplicatesLists(original, filter):
    """ return 'filter' filtered. so that all stuff in filter
        is unique in regard to 'original'.
    """
    nlist=[]
    for each in filter:
        if each not in original:
            nlist.append(each)
    return nlist

def manylists2one(listlists):
    """ make [['a','b'],['z']]
        into ['a','b','z']
    """
    nl=[]
    for each in listlists:
        if type(each)!=type([]):
            nl.append(each)
        else:
            for e in each:
                nl.append(e)
    return nl

def timeAsDateObject(t):
    """
        glue the time to any specific date
        and convert to a time object
    """
    return DateTime('1979/12/13 %s'%t)


def todaysDay():
    """
        return "monday" if today is a monday.
        Do not return it in local form
    """
    
    now = DateTime()
    return now.Day().lower()

def nowsTime():
    """
        return the hour now as the format
        we expect.
    """
    now = DateTime()
    time = "%s:%s"%(now.hour(), now.minute())

    return time

def wordInList(w,l):
    """
        this test...: if 'word' in alist:
        is limited by lettercase.
        This function lowercases everything first
        and returns true or false
    """
    for c in range(len(l)):
        try:
            l[c]=l[c].lower()
        except:
            pass
    # now for the test
    if w.lower() in l:
        return 1
    else:
        return 0
        

def cookTime(t):
    """
        prepare the value of t to help user pass the
        requirements of what the value should be

        Will for example convert 123 to 01:23
    """
    t = str(t).lower().strip()
    if t.count(':')==0:
        # hmm, perhaps like this: 0950 or 950
        if len(t)==4:
            t = "%s:%s"%(t[0:2],t[2:4])
        elif len(t)==3:
            t = "0%s:%s"%(t[0:1],t[1:3])
    return t

def cookDay(d):
    """ prepare the value of d to help user
    pass the requirements of what the value should
    be
    """
    d = str(d)
    d = d.strip().lower()
    abbrs ={'mon':'monday','tue':'tuesday','wed':'wednesday',
            'thu':'thursday','thur':'thursday','fri':'friday',
            'sat':'saturday','sun':'sunday'}
    if abbrs.has_key(d):
        d = abbrs[d]

    return d


def validTime(t):
    """ expect time to be   '00:00' or
                            '23:59' or
                            '5:00'

        '5:1' will not be accepted!
    """
    try:
        h,m = t.split(':')
        h=int(h)
        if not (h >=0 and h <24):
            return 0
        if not len(str(m))==2:
            return 0
        if not (int(m) >=0 and int(m) <60):
            return 0

        # still here then
        return 1
    except SyntaxError:
        raise
    except:
        return 0
    

if __name__=='__main__':
    hr = "= = = = = = = = = = = = = = ="
    print "\n\nTEST THINGS"
    print cookTime(950), "9:50"
    print cookTime(' 10:11 '), "10:11"

    print hr
    print cookDay('Tuesday '), "tuesday"
    print cookDay(' Wed'), "wednesday"

    print hr
    print "def wordInList(w,l):"
    print wordInList('HElp',['a','help'])
    print wordInList('HElp',['a','helps'])
    
    print hr
    print _removeExcessSpaces(" peter bengtsson  is    long ")
    

    
